# Class OjGanttBase

This is the base class for oj-gantt WebElement, and is generated from the component's metadata. Do not modify these contents since they'll be replaced during the next generation. Put overrides into the WebElements's subclass, OjGantt.ts.

#### Hierarchy

- OjWebElement
  - OjGanttBase
    - OjGantt

#####
Index

### Constructors

constructor

### Methods

changeScrollPosition
changeSelection
clear
click
findElement
findElements
getAnimationOnDataChange
getAnimationOnDisplay
getAs
getAttribute
getAxisPosition
getCssValue
getDependencies
getDependencyLineShape
getDnd
getDragMode
getEnd
getGridlines
getLocation
getMajorAxis
getMinorAxis
getParentRowPosition
getProperty
getRect
getReferenceObjects
getRowAxis
getRowDefaults
getRows
getScrollPosition
getSelection
getSelectionBehavior
getSelectionMode
getSize
getStart
getTaskAggregation
getTaskDefaults
getText
getTimeCursor
getTooltip
getTrackResize
getTranslations
getValueFormats
getViewportEnd
getViewportStart
getZooming
hasSize
hasVisibility
isDisplayed
isEnabled
isSelected
sendKeys
setProperty
submit
takeScreenshot
whenBusyContextReady
whenReady

## Constructors

### constructor

- new OjGanttBase(el, locators): OjGanttBase

- Constructor. Pass an instance of WebDriver's WebElement that represents the DOM node on which we"ll perform operations.

  #### Parameters

  - ##### el: WebElement

    The basic WebElement with which this WebElement will work.

  - ##### locators: ElementLocators

  #### Returns OjGanttBase

  Inherited from OjWebElement.constructor

## Methods

### changeScrollPosition

- changeScrollPosition(scrollPosition): Promise<void>

- Sets the value of `scrollPosition` property. The current scroll position of the Gantt. See the Help documentation for more information.

  #### Parameters

  - ##### scrollPosition: ScrollPosition

    The value to set for `scrollPosition`

  #### Returns Promise<void>

### changeSelection

- changeSelection(selection): Promise<void>

- Sets the value of `selection` property. An array containing the ids of the initially selected tasks.

  #### Parameters

  - ##### selection: any[]

    The value to set for `selection`

  #### Returns Promise<void>

### clear

- clear(): Promise<void>

- #### Returns Promise<void>

  #### Inherit Doc

  Inherited from OjWebElement.clear

### click

- click(): Promise<void>

- #### Returns Promise<void>

  #### Inherit Doc

  Inherited from OjWebElement.click

### findElement

- findElement(locator): WebElementPromise

- #### Parameters

  - ##### locator: Locator

  #### Returns WebElementPromise

  #### Inherit Doc

  Inherited from OjWebElement.findElement

### findElements

- findElements(locator): Promise<WebElement[]>

- #### Parameters

  - ##### locator: Locator

  #### Returns Promise<WebElement[]>

  #### Inherit Doc

  Inherited from OjWebElement.findElements

### getAnimationOnDataChange

- getAnimationOnDataChange(): Promise<string>

- Gets the value of `animationOnDataChange` property. Defines the animation that is applied on data changes.

  #### Returns Promise<string>

  The value of `animationOnDataChange` property.

### getAnimationOnDisplay

- getAnimationOnDisplay(): Promise<string>

- Gets the value of `animationOnDisplay` property. Defines the animation that is shown on initial display.

  #### Returns Promise<string>

  The value of `animationOnDisplay` property.

### getAs

- getAs(): Promise<string>

- Gets the value of `as` property. An alias for the '$current' context variable passed to slot content for the dependencyTemplate, taskTemplate, or rowTemplate slots.

  #### Returns Promise<string>

  The value of `as` property.

  #### Deprecated

  Since 6.2.0. Set the alias directly on the template element using the data-oj-as attribute instead.

### getAttribute

- getAttribute(attributeName): Promise<string>

- #### Parameters

  - ##### attributeName: string

  #### Returns Promise<string>

  #### Inherit Doc

  Inherited from OjWebElement.getAttribute

### getAxisPosition

- getAxisPosition(): Promise<string>

- Gets the value of `axisPosition` property. The position of the major and minor axis.

  #### Returns Promise<string>

  The value of `axisPosition` property.

### getCssValue

- getCssValue(cssStyleProperty): Promise<string>

- #### Parameters

  - ##### cssStyleProperty: string

  #### Returns Promise<string>

  #### Inherit Doc

  Inherited from OjWebElement.getCssValue

### getDependencies

- getDependencies(): Promise<null | Dependencies[]>

- Gets the value of `dependencies` property. An array of objects that defines dependencies between tasks. See the Help documentation for more information.

  #### Returns Promise<null | Dependencies[]>

  The value of `dependencies` property.

### getDependencyLineShape

- getDependencyLineShape(): Promise<string>

- Gets the value of `dependencyLineShape` property. Specifies the shape of the dependency lines.

  #### Returns Promise<string>

  The value of `dependencyLineShape` property.

### getDnd

- getDnd(): Promise<Dnd>

- Gets the value of `dnd` property. Enables drag and drop functionality.

  #### Returns Promise<Dnd>

  The value of `dnd` property.

### getDragMode

- getDragMode(): Promise<string>

- Gets the value of `dragMode` property. Specifies the action that is performed when a drag occurs.

  #### Returns Promise<string>

  The value of `dragMode` property.

### getEnd

- getEnd(): Promise<string>

- Gets the value of `end` property. The end time of the Gantt. See the Help documentation for more information.

  #### Returns Promise<string>

  The value of `end` property.

### getGridlines

- getGridlines(): Promise<Gridlines>

- Gets the value of `gridlines` property. An object specifying whether to display or hide the horizontal and vertical grid lines.

  #### Returns Promise<Gridlines>

  The value of `gridlines` property.

### getLocation

- getLocation(): Promise<ILocation>

- #### Returns Promise<ILocation>

  #### Inherit Doc

  Inherited from OjWebElement.getLocation

### getMajorAxis

- getMajorAxis(): Promise<MajorAxis>

- Gets the value of `majorAxis` property. Specifies the major time axis. If not specified, no major time axis is shown.

  #### Returns Promise<MajorAxis>

  The value of `majorAxis` property.

### getMinorAxis

- getMinorAxis(): Promise<MinorAxis>

- Gets the value of `minorAxis` property. Specifies the minor time axis. This is required for the Gantt to render properly.

  #### Returns Promise<MinorAxis>

  The value of `minorAxis` property.

### getParentRowPosition

- getParentRowPosition(): Promise<string>

- Gets the value of `parentRowPosition` property. Specifies how parent rows behave when scrolling within the Gantt.

  #### Returns Promise<string>

  The value of `parentRowPosition` property.

### getProperty

- getProperty<T>(propertyName): Promise<T>

- Get a named property value from this component. This function will wait for the application's busy context to complete before attempting to get the property value.

  #### Type Parameters

  - #### T = string

  #### Parameters

  - ##### propertyName: string

    The name of the property

  #### Returns Promise<T>

  A Promise that yields a value for the named property.

  Inherited from OjWebElement.getProperty

### getRect

- getRect(): Promise<IRectangle>

- #### Returns Promise<IRectangle>

  #### Inherit Doc

  Inherited from OjWebElement.getRect

### getReferenceObjects

- getReferenceObjects(): Promise<ReferenceObjects[]>

- Gets the value of `referenceObjects` property. The array of reference objects associated with the Gantt. See the Help documentation for more information.

  #### Returns Promise<ReferenceObjects[]>

  The value of `referenceObjects` property.

### getRowAxis

- getRowAxis(): Promise<RowAxis>

- Gets the value of `rowAxis` property. Specifies properties for the row labels region.

  #### Returns Promise<RowAxis>

  The value of `rowAxis` property.

### getRowDefaults

- getRowDefaults(): Promise<RowDefaults>

- Gets the value of `rowDefaults` property. Specifies default styling for rows in the Gantt.

  #### Returns Promise<RowDefaults>

  The value of `rowDefaults` property.

### getRows

- getRows(): Promise<null | Rows[]>

- Gets the value of `rows` property. An array of objects used to define rows and tasks within rows. See the Help documentation for more information.

  #### Returns Promise<null | Rows[]>

  The value of `rows` property.

### getScrollPosition

- getScrollPosition(): Promise<ScrollPosition>

- Gets the value of `scrollPosition` property. The current scroll position of the Gantt. See the Help documentation for more information.

  #### Returns Promise<ScrollPosition>

  The value of `scrollPosition` property.

### getSelection

- getSelection(): Promise<any[]>

- Gets the value of `selection` property. An array containing the ids of the initially selected tasks.

  #### Returns Promise<any[]>

  The value of `selection` property.

### getSelectionBehavior

- getSelectionBehavior(): Promise<string>

- Gets the value of `selectionBehavior` property. Specifies the action that is performed when a drag occurs.

  #### Returns Promise<string>

  The value of `selectionBehavior` property.

### getSelectionMode

- getSelectionMode(): Promise<string>

- Gets the value of `selectionMode` property. Specifies the selection behavior of the Gantt. See the Help documentation for more information.

  #### Returns Promise<string>

  The value of `selectionMode` property.

### getSize

- getSize(): Promise<ISize>

- #### Returns Promise<ISize>

  #### Inherit Doc

  Inherited from OjWebElement.getSize

### getStart

- getStart(): Promise<string>

- Gets the value of `start` property. The start time of the Gantt. A valid value is required for the Gantt to render properly. See the Help documentation for more information.

  #### Returns Promise<string>

  The value of `start` property.

### getTaskAggregation

- getTaskAggregation(): Promise<string>

- Gets the value of `taskAggregation` property. Specifies whether to apply a horizontally stacked visual treatment to adjacent tasks.

  #### Returns Promise<string>

  The value of `taskAggregation` property.

### getTaskDefaults

- getTaskDefaults(): Promise<TaskDefaults>

- Gets the value of `taskDefaults` property. Specifies default styling for tasks in the Gantt.

  #### Returns Promise<TaskDefaults>

  The value of `taskDefaults` property.

### getText

- getText(): Promise<string>

- #### Returns Promise<string>

  #### Inherit Doc

  Inherited from OjWebElement.getText

### getTimeCursor

- getTimeCursor(): Promise<string>

- Gets the value of `timeCursor` property. Specifies whether the time cursor is enabled.

  #### Returns Promise<string>

  The value of `timeCursor` property.

### getTooltip

- getTooltip(): Promise<Tooltip>

- Gets the value of `tooltip` property. An object containing an optional callback function for tooltip customization.

  #### Returns Promise<Tooltip>

  The value of `tooltip` property.

### getTrackResize

- getTrackResize(): Promise<string>

- Gets the value of `trackResize` property. Defines whether the element will automatically render in response to changes in size. See the Help documentation for more information.

  #### Returns Promise<string>

  The value of `trackResize` property.

### getTranslations

- getTranslations(): Promise<null | Translations>

- Gets the value of `translations` property. A collection of translated resources from the translation bundle, or null if this component has no resources.

  #### Returns Promise<null | Translations>

  The value of `translations` property.

### getValueFormats

- getValueFormats(): Promise<ValueFormats>

- Gets the value of `valueFormats` property. An object specifying value formatting and tooltip behavior, whose keys generally correspond to task properties.

  #### Returns Promise<ValueFormats>

  The value of `valueFormats` property.

### getViewportEnd

- getViewportEnd(): Promise<string>

- Gets the value of `viewportEnd` property. The Gantt viewport end time. See the Help documentation for more information.

  #### Returns Promise<string>

  The value of `viewportEnd` property.

### getViewportStart

- getViewportStart(): Promise<string>

- Gets the value of `viewportStart` property. The Gantt viewport start time. See the Help documentation for more information.

  #### Returns Promise<string>

  The value of `viewportStart` property.

### getZooming

- getZooming(): Promise<string>

- Gets the value of `zooming` property. Specifies whether zooming is allowed on the Gantt.

  #### Returns Promise<string>

  The value of `zooming` property.

### `Protected` hasSize

- hasSize(): Condition<Promise<boolean>>

- Create a wait condition that is satisfied when the element's DOM has a non-zero size.

  #### Returns Condition<Promise<boolean>>

  The Condition to be used with driver.wait() that's satisfied when the element's DOM has a non-zero size.

  #### Deprecated

  Since 11.0.0. Call the appropriate WebElement method to test the size of the element.

  Inherited from OjWebElement.hasSize

### `Protected` hasVisibility

- hasVisibility(): Condition<Promise<boolean>>

- Create a wait condition that is satisfid when the element is visible. The condition is satisfied when the element is displayed, as reported by #isDisplayed, and is scrolled into view. This is method is deprecated. Use WebElement.isDisplayed instead to test the display of the element, and scroll it into view if necessary.

  #### Returns Condition<Promise<boolean>>

  #### Deprecated

  Inherited from OjWebElement.hasVisibility

### isDisplayed

- isDisplayed(): Promise<boolean>

- #### Returns Promise<boolean>

  #### Inherit Doc

  Inherited from OjWebElement.isDisplayed

### isEnabled

- isEnabled(): Promise<boolean>

- #### Returns Promise<boolean>

  #### Inherit Doc

  Inherited from OjWebElement.isEnabled

### isSelected

- isSelected(): Promise<boolean>

- #### Returns Promise<boolean>

  #### Inherit Doc

  Inherited from OjWebElement.isSelected

### sendKeys

- sendKeys(...varArgs): Promise<void>

- #### Parameters

  - ##### `Rest` ...varArgs: (string | number | Promise<string | number>)[]

  #### Returns Promise<void>

  #### Inherit Doc

  Inherited from OjWebElement.sendKeys

### `Protected` setProperty

- setProperty<T>(propertyName, value): Promise<void>

- Set a property value on the remote element. This function first waits for the BusyContext to clear before setting the property, then after setting, waits again to ensure that no additional busy states were created due to the property setting.

  #### Type Parameters

  - #### T = string

  #### Parameters

  - ##### propertyName: string

    The property name to set

  - ##### value: T

    The value to set for the property

  #### Returns Promise<void>

  A Promise which resolves when the remote property has been set to the value. Any value returned from the call to set the remote property is returned in the Promise.

  Inherited from OjWebElement.setProperty

### submit

- submit(): Promise<void>

- #### Returns Promise<void>

  #### Inherit Doc

  Inherited from OjWebElement.submit

### takeScreenshot

- takeScreenshot(optScroll?): Promise<string>

- #### Parameters

  - ##### `Optional` optScroll: boolean

  #### Returns Promise<string>

  #### Inherit Doc

  Inherited from OjWebElement.takeScreenshot

### whenBusyContextReady

- whenBusyContextReady(): Promise<void>

- Returns a Promise that is resolved when the application's busy state reports ready. This method checks only that the application's busy context is ready, and not that the DOM element is actually displayed or has a physical size, such as is the case with #whenReady. Operations which are read-only in nature should call this method prior to execution.

  #### Returns Promise<void>

  A Promise which is resolved when the page's busy state is ready.

  Inherited from OjWebElement.whenBusyContextReady

### whenReady

- whenReady(): Promise<void>

- Returns a Promise that is resolved when the element is ready for interaction--it is visible, has a size, and the app's busy context is ready. Operations on the DOM which rely on its physical location and size to be in a "ready" state should use this command, such as clicking, sending keys, locating child elements, and so on.

  #### Returns Promise<void>

  A Promise that's resolved when all conditions are met.

  Inherited from OjWebElement.whenReady

Generated using TypeDoc